package com.oracle.coherencebpelintregration.eventpublisher;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;


/*  This Java class takes a guid and input argument
 *  and pushes them on the ache in order to get processed by a remote service
 *  The response gets received from the cache as well and then responded back
 *  to the caller.
 *
 *  @author: ingo.laue@oracle.com, 16-Oct-2007
 */

public class SayHelloWorldProxy {

    final long TIMEOUT = 4000; //timeout of service in milliseconds


    public String callSayHelloProcess(String guid, 
                                      String input) throws Exception {
        NamedCache cache = CacheFactory.getCache("VirtualCache");
        cache.put("SayHelloProcessRequest" + guid.toString(), input);


        long startTime = System.currentTimeMillis();

        String response = "";
        String responseKey="SayHelloProcessResponse" + guid.toString();
        while (!cache.keySet().contains(responseKey) && 
               System.currentTimeMillis() < startTime + TIMEOUT) {}
         
        if (System.currentTimeMillis() >= startTime + TIMEOUT)  
           response="TIMEOUT !!";
        else 
            response = 
                    (String)cache.get(responseKey);
        
     
        if (response.length() == 0)
            response = "Error ocurred. Sorry";
        else
            cache.remove("SayHelloProcessResponse" + guid.toString());

        return response;
    }


}
